/* ===========================================================================
                             łN(VC++)

                                 Main.cpp

   =========================================================================== */
#include "Windows.h"

#include "Main.h"
#include "MessageDef.h"
#include "Command.h"
#include "MomoUtil.h"

#include <vector>

HINSTANCE g_hInstance;

/* [J֐` */
void GetVersion(char *, DWORD *, DWORD *);


// --------------------------------------------------------
//    R}h쐬B
// --------------------------------------------------------
void SetCommandData(PLUGIN_COMMAND_INFO *cmdInfo, int CommandID, const char *Name, const char *Caption, int DispMenu)
{
	cmdInfo->Name = (char *)malloc(strlen(Name) + 1);
	if (cmdInfo->Name != NULL)
		strcpy(cmdInfo->Name, Name);
	cmdInfo->Caption = (char *)malloc(strlen(Caption) + 1);
	if (cmdInfo->Caption != NULL)
		strcpy(cmdInfo->Caption, Caption);
	cmdInfo->CommandID = CommandID;
	cmdInfo->Attr = 0;
	cmdInfo->ResID = -1;
	cmdInfo->DispMenu = DispMenu;
	cmdInfo->TimerInterval = 0;
	cmdInfo->TimerCounter = 0;
}
PLUGIN_INFO* SetPluginInfo(void)
{
	PLUGIN_INFO *plugin;

	/* vOC\̂̐ */
	plugin = (PLUGIN_INFO *)malloc(sizeof(PLUGIN_INFO));
	if (plugin == NULL) return NULL;
	
	/* vOC̖O */
	plugin->Name = (char *)malloc(strlen(PLUGIN_NAME) + 1);
	if (plugin->Name != NULL)
		strcpy(plugin->Name, PLUGIN_NAME);
	/* vOCt@C */
	plugin->Filename = (char *)malloc(strlen(PLUGIN_FILENAME) + 1);
	if (plugin->Filename != NULL)
		strcpy(plugin->Filename, PLUGIN_FILENAME);
	/* vOC^Cv */
	plugin->PluginType = PLUGIN_TYPE;
	/* o[W̎擾 */
	GetVersion(PLUGIN_FILENAME, &plugin->VersionMS, &plugin->VersionLS);

	/* R}h擾 */
	//INIݒe擾
	char IniFileName[MAX_PATH];
	int i;

	MomoUtil::GetIniFileName(g_hInstance, IniFileName);
	std::vector<CCommand> CommandList;
	for(i = CMD_FIRST; i < CMD_LAST; i++) {
		CCommand cmd(i);
		if (cmd.GetIniData(IniFileName, "Command")) {
			CommandList.push_back(cmd);
		}
	}

	//̎擾
	PLUGIN_COMMAND_INFO *pCI;
	plugin->CommandCount = CommandList.size() + COMMAND_COUNT;
	pCI = (PLUGIN_COMMAND_INFO *)malloc(sizeof(PLUGIN_COMMAND_INFO) * plugin->CommandCount);
	plugin->Commands = pCI;

	//ݒ
	std::vector<CCommand>::iterator it;
	for (it = CommandList.begin(); it != CommandList.end(); it++) {
		SetCommandData(pCI++, it->GetCommandID(), it->GetCaption(), it->GetCaption(), dmHotKeyMenu);
	}

	//̑̃R}hݒ
	SetCommandData(pCI++, CMD_RELOAD_INI, "Reload Ini File", "ułNv̐ݒēǍ", dmSystemMenu | dmHotKeyMenu);

	return plugin;
}

// --------------------------------------------------------
//    vOC[hꂽƂɌĂ΂
// --------------------------------------------------------
BOOL Init(void)
{
	return TRUE;
}

// --------------------------------------------------------
//    vOCA[hꂽƂɌĂ΂
// --------------------------------------------------------
void Unload(void)
{
}

// --------------------------------------------------------
//    R}hsɌĂ΂
// --------------------------------------------------------
BOOL Execute(int CmdId, HWND hWnd)
{
	char IniFileName[MAX_PATH];

	if (CmdId >= CMD_FIRST && CmdId <= CMD_LAST) {
		CCommand cmd(CmdId);
		if (cmd.GetIniData(MomoUtil::GetIniFileName(g_hInstance, IniFileName), "Command")) {
			cmd.Execute();
		}
	} else if (CmdId == CMD_RELOAD_INI) {
		PLUGIN_INFO *plugin = SetPluginInfo();
		if (plugin != NULL) {
			TTBPlugin_SetPluginInfo(PLUGIN_HANDLE, plugin);
			FreePluginInfo(plugin);
		}
	}
	return TRUE;
}

// --------------------------------------------------------
//    O[otbNbZ[WĂ
// --------------------------------------------------------
void Hook(UINT Msg, DWORD wParam, DWORD lParam)
{
}


// --------------------------------------------------------
//    DLLMain
// --------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
		g_hInstance = hInstance;
	return TRUE;
}
#endif

// --------------------------------------------------------
//    o[WԂ
// --------------------------------------------------------
static void GetVersion(char *Filename, DWORD *VersionMS, DWORD *VersionLS)
{
	DWORD	Size;
	LPDWORD	hVersion;
	LPVOID	pVersionInfo;
	VS_FIXEDFILEINFO	*FixedFileInfo;
	UINT	ItemLen;


	*VersionMS = 0;
	*VersionLS = 0;

	hVersion = NULL;

	Size = GetFileVersionInfoSize(Filename, hVersion);
	if (Size == 0) return;

	pVersionInfo = (LPVOID)malloc(Size);
	if (pVersionInfo == NULL) return;

	GetFileVersionInfo(Filename, 0, Size, pVersionInfo);

	if (VerQueryValue(pVersionInfo, "\\", (void **)&FixedFileInfo, &ItemLen)) {
		*VersionMS = FixedFileInfo->dwFileVersionMS;
		*VersionLS = FixedFileInfo->dwFileVersionLS;
	}

	free(pVersionInfo);
}
